const { DataTypes } = require("sequelize");

module.exports = (sequelize) => {
	const Occupation = sequelize.define(
		"occupation",
		{
			id: {
				type: DataTypes.INTEGER,
				autoIncrement: true,
				primaryKey: true,
			},
			creation: { type: DataTypes.DATE, allowNull: false },
			modified: { type: DataTypes.DATE, allowNull: false },
			modified_by: { type: DataTypes.INTEGER, allowNull: false },
			owner: { type: DataTypes.INTEGER, allowNull: false },
			enabled: { type: DataTypes.BOOLEAN, allowNull: false },

			// main
			name: { type: DataTypes.STRING(50), allowNull: false },
			display_name: { type: DataTypes.STRING(50), allowNull: false },

			// fk
			company_id: {
				type: DataTypes.INTEGER,
				allowNull: true,
			},
		},
		{
			tableName: "occupations",
			freezeTableName: true,
		}
	);

	/**
	 * Associates the Occupation model with other models.
	 * @param {object} models - The models to associate with.
	 * @description
	 */
	Occupation.associate = (models) => {
		Occupation.belongsTo(models.Company, { foreignKey: "company_id", as: "company" });
		Occupation.hasMany(models.Patient, { foreignKey: "occupation_id", as: "patients" });
	};

	return Occupation;
};
